/**
 * Copyright ProjectNya ( http://wonderfl.net/user/ProjectNya )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/z22D
 */

////////////////////////////////////////////////////////////////////////////////
// Blend Motion (あるみかん先生の混合率)
//
// [AS3.0] 異なる動きの移行制御 (3)
// http://www.project-nya.jp/modules/weblog/details.php?blog_id=1517
////////////////////////////////////////////////////////////////////////////////

package {

    import flash.display.Sprite;
    import flash.display.StageScaleMode;
    import flash.display.StageAlign;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.utils.Timer;
    import flash.events.TimerEvent;
    import flash.display.DisplayObject;
    import flash.display.Loader;
    import flash.net.URLRequest;
    import flash.system.Security;
    import flash.system.LoaderContext;
    import org.libspark.betweenas3.BetweenAS3;
    import org.libspark.betweenas3.tweens.ITween;
    import org.libspark.betweenas3.events.TweenEvent;
    import org.libspark.betweenas3.easing.*;

    [SWF(backgroundColor="#FFFFFF", width="465", height="465", frameRate="30")]

    public class Main extends Sprite {
        private var loader:Loader;
        private static var piyoPath:String = "http://www.project-nya.jp/images/seminar/wonderfl_piyo.swf";
        private var Piyo:Class;
        private var piyo:DisplayObject;
        private var playBtn:Btn;
        private var px:Number = 232;
        private var ax:Number = 232;
        private var tx:uint = 32;
        private static var deceleration:Number = 0.1;
        private var dx:Number = 0;
        private var angle:Number = 0;
        private static var speed:uint = 5;
        private static var radius:uint = 200;
        private static var basePos:uint = 232;
        private static var radian:Number = Math.PI/180;
        private var _percent:Number = 0;
        private var rect:Sprite;
        private var itween:ITween;
        private var next:Function;

        public function Main() {
            //Wonderfl.capture_delay(1);
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            init();
        }

        private function init():void {
            draw();
            //
            Security.allowDomain("www.project-nya.jp");
            loader = new Loader();
            loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loaded, false, 0, true);
            loader.load(new URLRequest(piyoPath), new LoaderContext(true));
            //
            playBtn = new Btn();
            addChild(playBtn);
            playBtn.x = 232;
            playBtn.y = 444;
            playBtn.init({label: "play"});
            playBtn.addEventListener(MouseEvent.CLICK, play, false, 0, true);
            playBtn.enabled = false;
            //
            rect = new Sprite();
            addChild(rect);
            rect.graphics.beginFill(0xCC0000);
            rect.graphics.drawRect(-4, -4, 8, 8);
            rect.graphics.endFill();
            rect.x = 32;
            rect.y = 414;
            //
            percent = 0;
        }
        private function loaded(evt:Event):void {
            loader.removeEventListener(Event.COMPLETE, loaded);
            //Piyoクラス
            Piyo = Class(loader.contentLoaderInfo.applicationDomain.getDefinition("jp.nya.project.character.Piyo"));
            setup();
            loader = null;
        }
        private function setup():void {
            playBtn.enabled = true;
            //
            piyo = new Piyo();
            addChild(piyo);
            piyo.x = 232;
            piyo.y = 350;
            Piyo(piyo).scale = 2.5;
            Piyo(piyo).mouseChildren = false;
        }
        private function play(evt:MouseEvent):void {
            playBtn.selected = true;
            //
            addEventListener(Event.ENTER_FRAME, update, false, 0, true);
            start();
        }
        private function start():void {
            itween = BetweenAS3.to(this, {percent: 1}, 5, Linear.easeNone);
            itween.addEventListener(TweenEvent.COMPLETE, turned, false, 0, true);
            itween.play();
        }
        private function turned(evt:TweenEvent):void {
            itween.removeEventListener(TweenEvent.COMPLETE, turned);
            //
            wait(2, turn);
        }
        private function turn():void {
            itween = BetweenAS3.to(this, {percent: 0}, 5, Linear.easeNone);
            itween.addEventListener(TweenEvent.COMPLETE, complete, false, 0, true);
            itween.play();
        }
        private function complete(evt:TweenEvent):void {
            itween.removeEventListener(TweenEvent.COMPLETE, complete);
            //
            wait(2, start);
        }
        private function wait(time:Number, func:Function):void {
            var timer:Timer = new Timer(2000, 1);
            timer.addEventListener(TimerEvent.TIMER_COMPLETE, waited, false, 0, true);
            timer.start();
            //
            next = func;
        }
        private function waited(evt:TimerEvent):void {
            evt.target.removeEventListener(TimerEvent.TIMER_COMPLETE, waited);
            //
            next();
        }
        public function get percent():Number {
            return _percent;
        }
        public function set percent(value:Number):void {
            _percent = value;
            rect.x = 32 + 400*_percent;
        }
        private function update(evt:Event):void {
            ax += (tx - ax)*deceleration;
            if (Math.abs(tx - ax) < 0.5) {
                ax = tx;
                if (itween && !itween.isPlaying) {
                    tx = (tx == 32) ? 232 : 32;
                }
            }
            angle += speed;
            dx = basePos + radius*Math.sin(angle*radian);
            piyo.x = blend();
        }
        private function blend():Number {
            var px:Number = ax*(1 - percent) + dx*percent;
            return px;
        }
        private function draw():void {
            var sky:Sky = new Sky(465, 320);
            addChild(sky);
            var ground:Ground = new Ground(465, 80);
            addChild(ground);
            ground.y = 320;
            var label:Label = new Label(200, 30, 30, Label.CENTER);
            addChild(label);
            label.x = 132;
            label.y = 100;
            label.textColor = 0xFFFFFF;
            label.alpha = 0.6;
            label.text = "blend motion";
            //
            var line:Sprite = new Sprite();
            addChild(line);
            line.graphics.beginFill(0xEEEEEE);
            line.graphics.drawRect(-204, -4, 408, 8);
            line.graphics.endFill();
            line.x = 232;
            line.y = 414;
            //
            var labelL:Label = new Label(20, 10, 10, Label.CENTER);
            addChild(labelL);
            labelL.x = 22;
            labelL.y = 424;
            labelL.textColor = 0x333333;
            labelL.text = "0%";
            var labelR:Label = new Label(20, 10, 10, Label.CENTER);
            addChild(labelR);
            labelR.x = 422;
            labelR.y = 424;
            labelR.textColor = 0x333333;
            labelR.text = "100%";
        }
        
    }

}
//////////////////////////////////////////////////
// Btnクラス
//////////////////////////////////////////////////

import flash.display.Sprite;
import flash.display.Shape;
import flash.text.TextField;
import flash.text.TextFieldType;
import flash.text.AntiAliasType;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.filters.GlowFilter;
import flash.events.MouseEvent;

class Btn extends Sprite {
    public var id:uint;
    private var shade:Shape;
    private var bottom:Shape;
    private var light:Shape;
    private var base:Shape;
    private var txt:TextField;
    private var label:String = "";
    private static var fontType:String = "_ゴシック";
    private var _width:uint = 60;
    private static var _height:uint = 20;
    private static var corner:uint = 5;
    private var type:uint = 1;
    private static var bColor:uint = 0xFFFFFF;
    private static var sColor:uint = 0x000000;
    private static var upColor:uint = 0x666666;
    private static var overColor:uint = 0x333333;
    private static var offColor:uint = 0x999999;
    private static var gColor:uint = 0x0099FF;
    private var blueGlow:GlowFilter;
    private var shadeGlow:GlowFilter;
    private var _selected:Boolean = false;
    private var _enabled:Boolean = true;

    public function Btn() {
    }

    public function init(option:Object):void {
        if (option.id != undefined) id = option.id;
        if (option.label != undefined) label = option.label;
        if (option.width != undefined) _width = option.width;
        if (option.type != undefined) type = option.type;
        draw();
    }
    private function draw():void {
        switch (type) {
            case 1 :
                bColor = 0xFFFFFF;
                sColor = 0x000000;
                upColor = 0x666666;
                overColor = 0x333333;
                offColor = 0x999999;
                break;
            case 2 :
                bColor = 0x000000;
                sColor = 0xFFFFFF;
                upColor = 0x666666;
                overColor = 0x999999;
                offColor = 0x333333;
                break;
        }
        blueGlow = new GlowFilter(gColor, 0.6, 5, 5, 2, 3, false, true);
        shadeGlow = new GlowFilter(sColor, 0.3, 4, 4, 2, 3, false, true);
        shade = new Shape();
        bottom = new Shape();
        light = new Shape();
        base = new Shape();
        txt = new TextField();
        addChild(shade);
        addChild(bottom);
        addChild(light);
        addChild(base);
        addChild(txt);
        createBase(shade, _width, _height, corner, sColor);
        shade.filters = [shadeGlow];
        createBase(bottom, _width, _height, corner, sColor, 0.3);
        createBase(light, _width, _height, corner, gColor);
        light.filters = [blueGlow];
        createBase(base, _width, _height, corner, bColor);
        txt.x = -_width*0.5;
        txt.y = -_height*0.5;
        txt.width = _width;
        txt.height = _height - 1;
        txt.type = TextFieldType.DYNAMIC;
        txt.selectable = false;
        //txt.embedFonts = true;
        //txt.antiAliasType = AntiAliasType.ADVANCED;
        var tf:TextFormat = new TextFormat();
        tf.font = fontType;
        tf.size = 12;
        tf.align = TextFormatAlign.CENTER;
        txt.defaultTextFormat = tf;
        txt.text = label;
        enabled = true;
        mouseChildren = false;
    }
    private function rollOver(evt:MouseEvent):void {
        _over();
    }
    private function rollOut(evt:MouseEvent):void {
        _up();
    }
    private function press(evt:MouseEvent):void {
        _down();
    }
    private function release(evt:MouseEvent):void {
        _up();
    }
    private function click(evt:MouseEvent):void {
    }
    private function _up():void {
        txt.y = -_height*0.5;
        txt.textColor = upColor;
        base.y = -1;
        light.visible = false;
        light.y = -1;
    }
    private function _over():void {
        txt.y = -_height*0.5;
        txt.textColor = overColor;
        base.y = -1;
        light.visible = true;
        light.y = -1;
    }
    private function _down():void {
        txt.y = -_height*0.5 + 1;
        txt.textColor = overColor;
        base.y = 0;
        light.visible = true;
        light.y = 0;
    }
    private function _off():void {
        txt.y = -_height*0.5 + 1;
        txt.textColor = offColor;
        base.y = 0;
        light.visible = false;
        light.y = 0;
    }
    public function get selected():Boolean {
        return _selected;
    }
    public function set selected(param:Boolean):void {
        _selected = param;
        enabled = !_selected;
        if (_selected) {
            _down();
        } else {
            _up();
        }
    }
    public function get enabled():Boolean {
        return _enabled;
    }
    public function set enabled(param:Boolean):void {
        _enabled = param;
        buttonMode = _enabled;
        mouseEnabled = _enabled;
        useHandCursor = _enabled;
        if (_enabled) {
            _up();
            addEventListener(MouseEvent.MOUSE_OVER, rollOver, false, 0, true);
            addEventListener(MouseEvent.MOUSE_OUT, rollOut, false, 0, true);
            addEventListener(MouseEvent.MOUSE_DOWN, press, false, 0, true);
            addEventListener(MouseEvent.MOUSE_UP, release, false, 0, true);
            addEventListener(MouseEvent.CLICK, click, false, 0, true);
        } else {
            _off();
            removeEventListener(MouseEvent.MOUSE_OVER, rollOver);
            removeEventListener(MouseEvent.MOUSE_OUT, rollOut);
            removeEventListener(MouseEvent.MOUSE_DOWN, press);
            removeEventListener(MouseEvent.MOUSE_UP, release);
            removeEventListener(MouseEvent.CLICK, click);
        }
    }
    private function createBase(target:Shape, w:uint, h:uint, c:uint, color:uint, alpha:Number = 1):void {
        target.graphics.beginFill(color, alpha);
        target.graphics.drawRoundRect(-w*0.5, -h*0.5, w, h, c*2);
        target.graphics.endFill();
    }

}


//////////////////////////////////////////////////
// Labelクラス
//////////////////////////////////////////////////

import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFieldType;
import flash.text.TextFieldAutoSize;
import flash.text.AntiAliasType;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

class Label extends Sprite {
    private var txt:TextField;
    private static var fontType:String = "_ゴシック";
    private var _width:uint = 20;
    private var _height:uint = 20;
    private var size:uint = 12;
    public static const LEFT:String = TextFormatAlign.LEFT;
    public static const CENTER:String = TextFormatAlign.CENTER;
    public static const RIGHT:String = TextFormatAlign.RIGHT;

    public function Label(w:uint, h:uint, s:uint = 12, align:String = LEFT) {
        _width = w;
        _height = h;
        size = s;
        draw(align);
    }

    private function draw(align:String):void {
        txt = new TextField();
        addChild(txt);
        txt.width = _width;
        txt.height = _height;
        txt.autoSize = align;
        txt.type = TextFieldType.DYNAMIC;
        txt.selectable = false;
        //txt.embedFonts = true;
        //txt.antiAliasType = AntiAliasType.ADVANCED;
        var tf:TextFormat = new TextFormat();
        tf.font = fontType;
        tf.size = size;
        tf.align = align;
        txt.defaultTextFormat = tf;
        textColor = 0x000000;
    }
    public function set text(param:String):void {
        txt.text = param;
    }
    public function set textColor(param:uint):void {
        txt.textColor = param;
    }

}


//////////////////////////////////////////////////
// Skyクラス
//////////////////////////////////////////////////

import flash.display.Shape;
import flash.geom.Matrix;
import flash.display.GradientType;

class Sky extends Shape {
    private static var _width:uint;
    private static var _height:uint;
    private static var color1:uint = 0x0069A0;
    private static var color2:uint = 0x00AAE4;

    public function Sky(w:uint, h:uint) {
        _width = w;
        _height = h;
        draw();
    }

    private function draw():void {
        var colors:Array = [color1, color2];
        var alphas:Array = [1, 1];
        var ratios:Array = [0, 255];
        var matrix:Matrix = new Matrix();
        matrix.createGradientBox(_width, _height, 0.5*Math.PI, 0, 0);
        graphics.beginGradientFill(GradientType.LINEAR, colors, alphas, ratios, matrix);
        graphics.drawRect(0, 0, _width, _height);
        graphics.endFill();
    }

}


//////////////////////////////////////////////////
// Groundクラス
//////////////////////////////////////////////////

import flash.display.Shape;
import flash.geom.Matrix;
import flash.display.GradientType;

class Ground extends Shape {
    private static var _width:uint;
    private static var _height:uint;
    private static var color1:uint = 0x99CC33;
    private static var color2:uint = 0x7EB133;

    public function Ground(w:uint, h:uint) {
        _width = w;
        _height = h;
        draw();
    }

    private function draw():void {
        var colors:Array = [color1, color2];
        var alphas:Array = [1, 1];
        var ratios:Array = [0, 255];
        var matrix:Matrix = new Matrix();
        matrix.createGradientBox(_width, _height, 0.5*Math.PI, 0, 0);
        graphics.beginGradientFill(GradientType.LINEAR, colors, alphas, ratios, matrix);
        graphics.drawRect(0, 0, _width, _height);
        graphics.endFill();
    }

}
